def loadRNA(filename):
    f=open(filename)
    rna={}
    for row in f:
        data=row.split()
        rna[data[0]]=data[1]
    return rna
    f.close()

def findMatches(seq,subseq):
    matches=[]
    start=0
    while start != -1:
        start=seq.find(subseq,start)
        if start > -1:
            matches.append(start)
            start+=1
    return matches

def findAllMatches(rna,subseq):
    for (name,seq) in rna.items():
        matches=findMatches(seq,subseq)
        if matches:
            print name,matches
    
def complementary(pattern):
    comp={"a" : "t", "t" : "a", "c" : "g", "g" : "c"}
    return "".join([comp[p] for p in pattern])

def findPerfectMatches(filename,pattern):
    rna=loadRNA(filename)
    comppattern=complementary(pattern)
    findAllMatches(rna,comppattern)

findPerfectMatches('utr.txt','acgaatt')
