
def loadPDB(filename):
    f=open(filename)
    l=[]
    for r in f.readlines():
        if not r.startswith("SEQRES"):
            continue
        data=r.split()[3:]
        l.extend(data)
    f.close()
    return l

def loadConversionTable(filename):
    f=open(filename)
    conv={}
    for r in f.readlines():
        data=r.split()
        conv[data[0]]=data[1]
    f.close()
    return conv

def three2one(three_list, table):
    seq=""
    for amino in three_list:
        seq += table[amino.lower()]
    return seq

def findOccurrences(pdbfile, conversion_table, subseq):
    three_list=loadPDB(pdbfile)
    table=loadConversionTable(conversion_table)
    seq = three2one(three_list, table)
    print seq.count(subseq)
